
/*
 * Definitions of functions.
 */

/*
 * If this is a personalized interpreter, include definitions from the
 *  pi directory.
 */

#ifdef PersInterp
#include "../pi/fdefs.h"
#endif					/* PersInterp */

/*
 * These are the functions in the standard repertoire.
 */

FncDef(abs,1)
FncDef(any,4)
FncDef(bal,6)
FncDef(center,3)
FncDef(char,1)
FncDef(close,1)
FncDef(collect,2)
FncDef(copy,1)
FncDef(cset,1)
FncDef(delete,2)
FncDefV(detab)
FncDef(display,2)
FncDefV(entab)
FncDef(errorclear,0)
FncDef(exit,1)
FncDef(find,4)
FncDef(get,2)
FncDef(getenv,1)
FncDef(iand,2)
FncDef(icom,1)
FncDef(image,1)
FncDef(insert,3)
FncDef(integer,1)
FncDef(ior,2)
FncDef(ishift,2)
FncDef(ixor,2)


FncDef(left,3)
FncDef(list,2)
FncDef(many,4)
FncDef(map,3)
FncDef(match,4)
FncDef(member,1)
FncDef(move,1)
FncDef(numeric,1)
FncDef(open,2)
FncDef(ord,1)
FncDef(pop,1)
FncDef(pos,1)
FncDef(proc,2)
FncDef(pull,1)
FncDef(push,2)
FncDef(put,1)
FncDef(read,2)
FncDef(reads,2)
FncDef(real,1)
FncDef(remove,2)
FncDef(rename,1)
FncDef(repl,2)
FncDef(reverse,1)
FncDef(right,3)
FncDefV(runerr)
FncDef(seek,2)
FncDef(seq,2)
FncDef(set,1)
FncDef(sort,2)
FncDefV(stop)
FncDef(string,1)
FncDef(tab,1)
FncDef(table,1)
FncDef(trim,2)
FncDef(type,1)
FncDef(upto,4)
FncDef(where,1)
FncDefV(write)
FncDefV(writes)

/*
 * System functions.
 */

#ifdef SystemFncs
FncDef(system,1)
#endif					/* SystemFncs */

/*
 * Executable images.
 */

#ifdef ExecImages
FncDef(save,1)
#endif					/* ExecImages */

/*
 * Math functions.
 */

#ifdef MathFncs
FncDef(acos,1)
FncDef(asin,1)
FncDef(atan,2)
FncDef(cos,1)
FncDef(dtor,1)
FncDef(exp,2)
FncDef(log,1)
FncDef(rtod,1)
FncDef(sin,1)
FncDef(sqrt,1)
FncDef(tan,1)
#endif					/* MathFncs */

#ifdef KeyboardFncs
FncDef(getch,0)
FncDef(getche,0)
FncDef(kbhit,0)
#endif					/* KeyboardFncs */

/*
 * Functions for MS-DOS.
 */

#ifdef DosFncs
FncDef(Int86,1)
FncDef(Peek,1)
FncDef(Poke,1)
FncDef(GetSpace,1)
FncDef(FreeSpace,1)
FncDef(InPort,1)
FncDef(OutPort,1)
#endif					/* DosFncs */

/*
 * "Iscope" functions.
 */

#ifdef ScopeFncs
FncDef(Descr,1)
FncDef(Dword,1)
FncDef(Indir,1)
FncDef(Ivar,1)
FncDef(Symbol,1)
FncDef(Vword,1)
#endif					/* ScopeFncs */

/*
 * Memory monitoring functions.
 */

#ifdef MemMon
FncDef(mmout,1)
FncDef(mmpause,1)
FncDef(mmshow,2)
#endif					/* MemMon */

/*
 * Instrumentation functions.
 */

#ifdef InstrFncs
FncDef(runstats,1)
#endif					/* InstrFncs */

/*
 * Internal functions.
 */

#ifdef IntrnlFncs
FncDef(Blocks,0)
FncDef(descr,1)
FncDef(blkdump,0)
FncDef(functions,0)
FncDef(hash,1)
FncDef(block,1)
FncDef(Strings,0)
FncDef(Args,0)
FncDef(Arg,1)
FncDef(globalnames,0)
FncDef(globalvar,1)
FncDef(variable,1)
#endif					/* IntrnlFncs */

/*
 * String functions.
 */

#ifdef StringFncs
FncDef(collate,2)
FncDef(decollate,2)
FncDef(rotate,2)
FncDef(StringCopy,1)
#endif					/* StringFncs */

/*
 * Macintosh screen functions.
 */

#ifdef ScreenFncs
FncDef(Circle,3)
FncDef(Closepl,0)
FncDef(Cont,2)
FncDef(Eraseplot,0)
FncDef(Gotoxy,2)
FncDef(Label,1)
FncDef(Line,4)
FncDef(Movexy,2)
FncDef(Openpl,0)
FncDef(Point,2)
#endif					/* ScreenFncs */


/*
 * Miscellaneous functions.
 */

#ifdef MiscFncs
FncDef(getpid,0)
FncDef(fsize,1)
FncDef(readc,1)
FncDef(tmpnam,0)
#endif					/* MiscFncs */

#if VM
FncDef(cmssystem,3)
#endif					/* VM */

