/*
 * Memory sizing. 
 */

#ifdef FixedRegions
#undef IconAlloc
#ifndef AlcMax
#define AlcMax 25
#endif					/* AlcMax */
#endif					/* FixedRegions */

/*
 * Maximum sized block that can be allocated (via malloc() or such).
 */

#ifndef MaxBlock
#define MaxBlock MaxUnsigned
#endif					/* MaxBlock */

/*
 * What follows is default memory sizing. Implementations with special
 *  requirements may specify these values in define.h.
 */

#ifndef MaxStatSize
#ifdef Coexpr
#define MaxStatSize		20480	/* size of the static region in bytes*/
#else					/* Coexpr */
#define MaxStatSize		 1024	/* size of the static region in bytes */
#endif					/* Coexpr */
#endif					/* MaxStatSize */

#ifndef MaxStrSpace
#define MaxStrSpace		65000	/* size of the string space in bytes */
#endif					/* MaxStrSpace */

#ifndef MaxAbrSize
#define MaxAbrSize		65000	/* size of the block region in bytes */
#endif					/* MaxAbrSize */

#ifndef MStackSize
#define MStackSize		10000	/* size of the main stack in words */
#endif					/* MStackSize */

#ifndef StackSize
#define StackSize		 2000	/* words in co-expression stack */
#endif					/* StackSize */

#ifndef QualLstSize
#define QualLstSize		 5000	/* size of qualifier pointer region */
#endif					/* QualLstSize */

#ifndef ActStkBlkEnts
#ifdef Coexpr
#define ActStkBlkEnts		  100	/* number of entries in an astkblk */
#else					/* Coexpr */
#define ActStkBlkEnts		    1	/* number of entries in an astkblk */
#endif					/* Coexpr */
#endif					/* ActStkBlkEnts */

/*
 * Minimum regions sizes (presently not used).
 */

#ifndef MinStatSize
#ifdef Coexpr
#define MinStatSize		10240	/* size of the static region in bytes*/
#else					/* Coexpr */
#define MinStatSize		 1024	/* size of static region in bytes */
#endif					/* Coexpr */
#endif					/* MinStatSize */

#ifndef MinStrSpace
#define MinStrSpace		 5000	/* size of the string space in bytes */
#endif					/* MinStrSpace */

#ifndef MinAbrSize
#define MinAbrSize		 5000	/* size of the block region in bytes */
#endif					/* MinAbrSize */

#ifndef MinMStackSize
#define MinMStackSize		 2000	/* size of the main stack in words */
#endif					/* MinMStackSize */

#ifndef MinStackSize
#define MinStackSize		 1000	/* words in co-expression stack */
#endif					/* MinStackSize */

#ifndef MinQualLstSize
#define MinQualLstSize		  500	/* size of qualifier pointer region */
#endif					/* MinQualLstSize */
