#ifdef PreProcess
/* undefine(`shift') undefine(`len') undefine(`syscmd') undefine(`index') */
#endif					/* PreProcess */

/*
 * This file contains "prototypes" for functions used by Icon. These are
 *  processed after system-dependent symbols and typedefs.
 *
 * There are two major sections: one for C compilers that accept full
 *  prototypes with arguments and one for C compilers that do not. The
 *  choice of section depends on whether Prototypes is defined.
 *
 * Within the major sections, prototypes are divided into three groups:
 *
 *	library functions
 *	functions in icont
 *	functions in iconx
 *
 * Notice that within groups, the functions are in alphabetical order
 *  except for a few special cases. This is merely to make it easier to
 *  maintain this file.
 *
 * Prototypes for some library functions are deliberately omitted, since
 *  they vary from compiler to compiler. Including those for free();
 *  sbrk(), and lsbrk().
 */

#ifdef Prototypes
/*
 * Prototypes with arguments.
 */

/*
 * Prototypes for library functions.
 */
novalue _exit(int);
novalue abort(noargs);
long atol(char *);
pointer calloc(unsigned,unsigned);
int execv(char *, char **);
int execvp(char *, char **);
novalue exit(int);
char *getenv(char *);
char *getmem(unsigned);
pointer malloc(msize);
pointer realloc(pointer, unsigned);
int system(char *);
int wait(noargs);


/*
 * Prototypes for functions in icont.
 */
novalue addlfile(char *name);
struct fentry *alcfhead(struct fentry *blink,char *name,int fid,struct rentry *rlist);
struct rentry *alcfrec(struct rentry *link,int rnum,int fnum);
struct tgentry *alcglob(struct tgentry *blink,char *name,int flag,int nargs);
struct gentry *alcglobal(struct gentry *blink,char *name,int flag,int nargs,int procid);
struct tientry *alcid(char *nam,int len);
struct ientry *alcident(char *nam,int len);
int alclab(int n);
struct lfile *alclfile(char *name);
struct tcentry *alclit(struct tcentry *blink,char *name,int len,int flag);
struct tlentry *alcloc(struct tlentry *blink,char *name,int flag);
pointer alloc(unsigned int n);
novalue alsolink(char *name);
novalue backpatch(int lab);
novalue binop(int op);
int blocate(char *s);
struct node *c_str_leaf(int type,struct node *loc_model,char *c);
int canread(char *file);
novalue cdump(char *);
novalue clearlab(noargs);
struct tcentry *clookup(char *id,int flag);
novalue codegen(struct node *t);
novalue cout(FILE *fd);
int ctlesc(noargs);
novalue dummyda(noargs);
novalue dumpblock(char *addr,int count);
novalue emit(char *s);
novalue emitl(char *s,int a);
novalue emitlab(int l);
novalue emitn(char *s,int a);
novalue emits(char *s,char *a);
novalue execute(char *ofile,char *efile,char * *args);
struct toktab *findres(noargs);
struct fentry *flocate(char *id);
novalue flushcode(noargs);
struct fileparts *fparse(char *s);
novalue gencode(noargs);
novalue gentables(noargs);
int getdec(noargs);
char *getid(noargs);
struct toktab *getident(int ac,int *cc);
long getint(noargs);
int getlab(noargs);
struct lfile *getlfile(struct lfile * *lptr);
struct toktab *getnum(int ac,int *cc);
int getoct(noargs);
int getopc(char * *id);
struct toktab *getopr(int ac,int *cc);
int getopt(int nargc,char * *nargv,char *ostr);
double getreal(noargs);
char *getrest(noargs);
char *getstr(noargs);
struct toktab *getstring(int ac,int *cc);
char *getstrlit(int l);
struct gentry *glocate(char *id);
struct tgentry *glookup(char *id);
novalue gout(FILE *fd);
int hexesc(noargs);
struct node *i_str_leaf(int type,struct node *loc_model,char *c,int d);
int ilink(char * *ifiles,char *outname);
novalue install(char *name,int flag,int argcnt);
char *instid(char *s);
unsigned int round2(unsigned int n);
struct node *int_leaf(int type,struct node *loc_model,int c);
novalue intout(int oint);
int klookup(char *id);
novalue lemit(int op,char *name);
novalue lemitcon(int k);
novalue lemiteven(noargs);
novalue lemitin(int op,word offset,int n,char *name);
novalue lemitint(int op,long i,char *name);
novalue lemitl(int op,int lab,char *name);
novalue lemitn(int op,word n,char *name);
novalue lemitproc(char *name,int nargs,int ndyn,int nstat,int fstat);
novalue lemitr(int op,word loc,char *name);
int lexeql(int l,char *s1,char *s2);
novalue lfatal(char *s1,char *s2);
novalue linit(noargs);
struct tlentry *llookup(char *id);
novalue lmfree(noargs);
novalue loc_init(noargs);
novalue locinit(noargs);
long longwrite(char *s,long len,FILE *file);
novalue lout(FILE *fd);
novalue lwarn(char *s1,char *s2,char *s3);
char *makename(char *dest,char *d,char *name,char *e);
char *mapterm(int typ,struct node *val);
novalue newline(noargs);
int nextchar(noargs);
novalue nfatal(struct node *n,char *s);
int octesc(int ac);
novalue outblock(char *addr,int count);
FILE *preprocess(char *filename);
/* novalue putconst(int n,int flags,int len,long pc,union UNNAMED *valp); */
novalue putfield(char *fname,int rnum,int fnum);
novalue putglob(char *id,int id_type,int n_args);
struct gentry *putglobal(char *id,int flags,int nargs,int procid);
char *putid(int len);
char *putident(int len);
int putlit(char *id,int idtype,int len);
int putloc(char *id,int id_type);
novalue putlocal(int n,char *id,int flags,int imperror,char *procname);
novalue quit(char *msg);
novalue quitf(char *msg,char *arg);
novalue readglob(noargs);
novalue report(char *s);
novalue rmfiles(char * *p);
novalue rout(FILE *fd,char *name);
char *salloc(char *s);
novalue setexe(char *fname);
int setfilenm(int c);
int setlineno(noargs);
novalue setloc(struct node *n);
novalue sizearg(char *arg,char * *argv);
int smatch(char *s,char *t);
int streq(int len,char *s1,char *s2);
pointer tcalloc(unsigned int m,unsigned int n);
novalue tfatal(char *s1,char *s2);
novalue tmalloc(noargs);
novalue tmfree(noargs);
novalue tminit(noargs);
int trans(char * *ifiles);
novalue trans1(char *filename);
int traverse(struct node *t);
struct node *tree1(int type);
struct node *tree2(int type,struct node *loc_model);
struct node *tree3(int type,struct node *loc_model,struct node *c);
struct node *tree4(int type,struct node *loc_model,struct node *c,struct node *d);
struct node *tree5(int type,struct node *loc_model,struct node *c,struct node *d,struct node *e);
struct node *tree6(int type,struct node *loc_model,struct node *c,struct node *d,struct node *e,struct node *f);
novalue treeinit(noargs);
int trypath(char *name,char *file);
novalue tsyserr(char *s);
novalue twarn(char *s1,char *s2);
novalue unopa(int op);
novalue unopb(int op);
novalue usage(noargs);
novalue wordout(word oword);
novalue writecheck(int rc);
novalue yyerror(int tok,struct node *lval,int state);
int yylex(noargs);
int yyparse(noargs);

/*
 * Prototypes for functions in iconx.
 */

int bfunc();
long ckadd(long i, long j);
long ckmul(long i, long j);
long cksub(long i, long j);
int coswitch(word *old, word *new, int first);
int dup2(int h1, int h2);
char *ecvt(double value, int count, int *dec, int* sign);
int getimage(dptr dp1, dptr dp2);
int getlist(struct b_lelem *bp,unsigned int *vals, int limit);
int inp(unsigned int port);

#if IntBits == 16
novalue llqsort(char *base, int nel, int width, int (*cmp)());
#endif					/* IntBits == 16 */

int outp(unsigned int port, int byte);
int printable(int c);
int putf(dptr dp, struct b_tvkywd *bp);
char *strchr(char *s, int i);
int strcmp(char *s1, char *s2);
char *strcpy();		/* prototype problem */
char *strncat(char *s1, char *s2, int n);
int strncmp(char *s1, char *s2, int n);
char *strncpy(char *s1, char *s2, int n);

#ifdef KeyboardFncs
int getch(noargs);
int getche(noargs);
int kbhit(noargs);
#endif					/* KeyboardFncs */

#define Fargs dptr cargp

#ifdef PreProcess
/* define(FncDef,int X$1(Fargs);) */
/* define(FncDefV,int X$1(int nargs,Fargs);) */
/* include(../h/fdefs.h) /* */
/* undefine(`FncDef') */
/* undefine(`FncDefV') */
/* */
/* define(OpDef,int O$1(Fargs);) */
/* include(../h/odefs.h) /* */
/* undefine(`OpDef') */
/* */
#else					/* PreProcesses */
#define FncDef(p,n) int Cat(X,p)(Fargs);
#define FncDefV(p) int Cat(X,p)(int nargs,Fargs);
#include "../h/fdefs.h"
#undef FncDef
#undef FncDefV
#define OpDef(p,n,s) int Cat(O,p)(Fargs);
#include "../h/odefs.h"
#undef OpDef
#endif					/* PreProcess */

novalue addmem(struct b_set *ps,struct b_selem *pe,dptr pl);
novalue adjust(char *source,char *dest);
struct astkblk *alcactiv(noargs);
struct b_coexpr *alccoexp(noargs);
struct b_cset *alccset(noargs);
struct b_external *alcextrnl(int n);
struct b_file *alcfile(FILE *fd,int status,dptr name);
struct b_list *alclist(uword size);
struct b_lelem *alclstb(uword nslots,uword first,uword nused);
struct b_real *alcreal(double val);
struct b_record *alcrecd(int nflds,dptr recptr);
struct b_refresh *alcrefresh(word *entryx,int na,int nl);
struct b_selem *alcselem(dptr mbr,word hn);
struct b_set *alcset(noargs);
char *alcstr(char *s,word slen);
struct b_tvsubs *alcsubs(word len,word pos,dptr var);
struct b_table *alctable(dptr def);
struct b_telem *alctelem(noargs);
struct b_tvtbl *alctvtbl(dptr tbl,dptr ref,word hashnum);
int anycmp(dptr dp1,dptr dp2);
novalue atrace(dptr sptr);
int blkreq(uword bytes);
union block *alcblk(uword nbytes,int tcode);
int Obscan(int nargs,Fargs);
novalue c_exit(int i);
novalue coacttrace(struct b_coexpr *ccp,struct b_coexpr *ncp);
novalue cofailtrace(struct b_coexpr *ccp,struct b_coexpr *ncp);
novalue cofree(noargs);
novalue collect(int region);
novalue compact(char *source);
novalue corettrace(struct b_coexpr *ccp,struct b_coexpr *ncp);
int cplist(dptr dp1,dptr dp2,word i,word j);
int Ocreate(word *entryp,Fargs);
int csetcmp(unsigned int *cs1,unsigned int *cs2);
int cstos(int *cs,dptr dp,char *s);
novalue ctrace(dptr sptr,int nargs,dptr arg);
int cvcset(dptr dp,int * *cs,int *csbuf);
int cvint(dptr dp,long *i);
int cvnum(dptr dp,union numeric *result);
word cvpos(long pos,long len);
int cvreal(dptr dp,double *r);
int cvstr(dptr dp,char *sbuf);
novalue datainit(noargs);
int defcset(dptr dp,int * *cp,int *buf,int *def);
int deffile(dptr dp,dptr def);
int defint(dptr dp,long *lp,word def);
int defshort(dptr dp,int def);
int defstr(dptr dp,char *buf,dptr def);
int deref(dptr dp);
int doasgn(dptr dp1,dptr dp2);
int doimage(int c,int q);
novalue env_err(char *msg,char *name,char *val);
novalue env_int(char *name,word *variable,int non_neg, uword limit);
int envset(noargs);
int equiv(dptr dp1,dptr dp2);
int err(noargs);
novalue error(char *s);
int Oescan(int nargs,Fargs);
novalue fatalerr(int n,dptr v);
int Ofield(int nargs,Fargs);
char *findfile(word *ipc);
int findline(word *ipc);
int fixtrap(noargs);
int fpetrap(noargs);
novalue failtrace(dptr sptr);
int getstrg(char *buf,int maxi,FILE *fd);
word hash(dptr dp);
char *icon_gcvt(double number,int ndigit,char *buf);
novalue iconhost(char *hostname);
novalue init(char *name);
novalue initalloc(word codesize);

int interp(int fsig,dptr cargp);

int invoke(int nargs,dptr  *cargp,int *n);
long ipow(long n1,long n2);
double pow();			/* prototype problem */
int itos(long num,dptr dp,char *s);
int Okeywd(int nargs,Fargs);
int lexcmp(dptr dp1,dptr dp2);
int Olimit(int nargs,Fargs);
novalue listimage(FILE *f,struct b_list *lp,int restrict);
int Ollist(int nargs,Fargs);
int locate(struct b_selem *ep,struct b_selem *obj);
word longread(char *s,int width,long len,FILE *fname);
long lstrlen(char *s);
novalue markblock(dptr dp);
dptr memb(struct b_set *ps,dptr x,word hn,int *res);
dptr memb_tbl(struct b_table *pt,dptr x,word hn,int *res);
pointer memcpy(char *dest,char *src, int c);
int mkreal(double r,dptr dp);
int Omkrec(int nargs,Fargs);
novalue mksubs(dptr var,dptr val,word i,word j,dptr result);
novalue mvc(uword n,char *src,char *dest);
int numcmp(dptr dp1,dptr dp2,dptr dp3);
int nxttab(int col);
int order(dptr dp);
novalue outimage(FILE *f,dptr dp,int restrict);
struct b_coexpr *popact(struct b_coexpr *ce);
novalue postqual(dptr dp);
word prescan(dptr d);
novalue printimage(FILE *f,int c,int q);
int pushact(struct b_coexpr *ce,struct b_coexpr *actvtr);
int putpos(dptr dp,struct b_tvkywd *bp);
int putstr(FILE *f,dptr d);
int putsub(dptr dp,struct b_tvkywd *bp);
int putint(dptr dp,struct b_tvkywd *bp);
int qlcmp(dptr  *q1,dptr  *q2);
novalue qswap(char *a, char *b, int w);
int qtos(dptr dp,char *sbuf);
int radix(char sign,int r,char *s,union numeric *result);
novalue reclaim(int region);
int resolve(noargs);
int rtos(double n,dptr dp,char *s);
novalue rtrace(dptr sptr,dptr rval);
novalue runerr(int n,dptr v);
novalue scollect(word extra);
int segvtrap(noargs);
novalue showlevel(int n);
novalue showline(char *f,int l);
novalue stkdump(int);
int ston(char *s,union numeric *result);
novalue strace(dptr sptr,dptr rval);
int strprc(dptr dp,word n);
int strreq(uword n);
novalue sweep(struct b_coexpr *ce);
novalue syserr(char *s);
struct b_coexpr *topact(struct b_coexpr *ce);
int trcmp3(struct dpair *dp1,struct dpair *dp2);
int trefcmp(dptr d1,dptr d2);
novalue ttrace(noargs);
int tvalcmp(dptr d1,dptr d2);
int tvcmp4(struct dpair *dp1,struct dpair *dp2);
novalue xdisp(struct pf_marker *fp,dptr dp,int count,FILE *f);
novalue xtrace(struct b_proc *bp,word nargs,dptr arg,int pline,char *pfile);

#ifdef MemMon
/* static */ novalue mmnewline(noargs);
/* static */ novalue mmcmd(word addr, word len, int c);
/* static */ novalue mmdec(uword n);
/* static */ novalue mmlen(word n, int c);
/* static */ novalue mmforget(noargs);
/* static */ novalue mmsizes(int c);
/* static */ novalue mmrefresh(noargs);
/* static */ novalue mmstatic(noargs);

/* static */ novalue MMPause(char *msg);
/* static */ novalue MMOut(char *prefix, char *msg);
/* static */ novalue MMShow(dptr d, char *s);

novalue MMInit(char *name);
novalue MMTerm(char *part1, char *part2);

novalue MMAlc(word len, int type);
novalue MMBGC(int region);
novalue MMEGC(noargs);
novalue MMMark(char *block, int type);
novalue MMStat(char *a, word n, int c);
novalue MMStr(word slen);
novalue MMSMark(char *saddr, word slen);
#endif					/* MemMon */


#else					/* Prototypes */

/*
 * Prototypes without arguments.
 */

/*
 * Prototypes for library functions.
 */
novalue _exit();
novalue abort();
long atol();
pointer calloc();
int execv();
int execvp();
novalue exit();
char *getenv();
char *getmem();
pointer malloc();
novalue qsort();
pointer realloc();
int system();
int wait();

/*
 * Prototypes for functions in icont.
 */
novalue addlfile();
struct fentry *alcfhead();
struct rentry *alcfrec();
struct tgentry *alcglob();
struct gentry *alcglobal();
struct tientry *alcid();
struct ientry *alcident();
int alclab();
struct lfile *alclfile();
struct tcentry *alclit();
struct tlentry *alcloc();
pointer alloc();
novalue alsolink();
novalue backpatch();
novalue binop();
int blocate();
struct node *c_str_leaf();
int canread();
novalue cdump();
novalue clearlab();
struct tcentry *clookup();
novalue codegen();
novalue cout();
int ctlesc();
novalue dummyda();
novalue dumpblock();
novalue emit();
novalue emitl();
novalue emitlab();
novalue emitn();
novalue emits();
novalue execute();
struct toktab *findres();
struct fentry *flocate();
novalue flushcode();
struct fileparts *fparse();
novalue gencode();
novalue gentables();
int getdec();
char *getid();
struct toktab *getident();
long getint();
int getlab();
struct lfile *getlfile();
struct toktab *getnum();
int getoct();
int getopc();
struct toktab *getopr();
int getopt();
double getreal();
char *getrest();
char *getstr();
struct toktab *getstring();
char *getstrlit();
struct gentry *glocate();
struct tgentry *glookup();
novalue gout();
int hexesc();
struct node *i_str_leaf();
int ilink();
novalue install();
char *instid();
unsigned int round2();
struct node *int_leaf();
novalue intout();
int klookup();
novalue lemit();
novalue lemitcon();
novalue lemiteven();
novalue lemitin();
novalue lemitint();
novalue lemitl();
novalue lemitn();
novalue lemitproc();
novalue lemitr();
int lexeql();
novalue lfatal();
novalue linit();
struct tlentry *llookup();
novalue lmfree();
novalue loc_init();
novalue locinit();
long longwrite();
novalue lout();
novalue lwarn();
char *makename();
char *mapterm();
novalue newline();
int nextchar();
novalue nfatal();
int octesc();
novalue outblock();
FILE *preprocess();
novalue putconst();
novalue putfield();
novalue putglob();
struct gentry *putglobal();
char *putid();
char *putident();
int putlit();
int putloc();
novalue putlocal();
novalue quit();
novalue quitf();
novalue readglob();
novalue report();
novalue rmfiles();
novalue rout();
char *salloc();
novalue setexe();
int setfilenm();
int setlineno();
novalue setloc();
novalue sizearg();
int smatch();
int streq();
pointer tcalloc();
novalue tfatal();
novalue tmalloc();
novalue tmfree();
novalue tminit();
int trans();
novalue trans1();
int traverse();
struct node *tree1();
struct node *tree2();
struct node *tree3();
struct node *tree4();
struct node *tree5();
struct node *tree6();
novalue treeinit();
int trypath();
novalue tsyserr();
novalue twarn();
novalue unopa();
novalue unopb();
novalue usage();
novalue wordout();
novalue writecheck();
novalue yyerror();
int yylex();
int yyparse();

/*
 * Prototypes for functions in iconx.
 */
#define FncDef(p,n) int Cat(X,p)();
#define FncDefV(p) int Cat(X,p)();
#include "../h/fdefs.h"
#undef FncDef
#undef FncDefV
#define OpDef(p,n,s) int Cat(O,p)();
#include "../h/odefs.h"
#undef OpDef

int bfunc();
long ckadd();
long ckmul();
long cksub();
int coswitch();
int dup2();
char *ecvt();
int getimage();
int getlist();
int inp();
novalue llqsort();
int outp();
int printable();
int putf();
char *strchr();
int strcmp();
char *strcpy();
char *strncat();
int strncmp();
char *strncpy();

#ifdef KeyboardFncs
int getch();
int getche();
int kbhit();
#endif					/* KeyboardFncs */

novalue addmem();
novalue adjust();
struct astkblk *alcactiv();
struct b_coexpr *alccoexp();
struct b_cset *alccset();
struct b_external *alcextrnl();
struct b_file *alcfile();
struct b_list *alclist();
struct b_lelem *alclstb();
struct b_real *alcreal();
struct b_record *alcrecd();
struct b_refresh *alcrefresh();
struct b_selem *alcselem();
struct b_set *alcset();
char *alcstr();
struct b_tvsubs *alcsubs();
struct b_table *alctable();
struct b_telem *alctelem();
struct b_tvtbl *alctvtbl();
int anycmp();
novalue atrace();
int blkreq();
union block *alcblk();
int Obscan();
novalue c_exit();
novalue coacttrace();
novalue cofailtrace();
novalue cofree();
novalue collect();
novalue compact();
novalue corettrace();
int cplist();
int Ocreate();
int csetcmp();
int cstos();
novalue ctrace();
int cvcset();
int cvint();
int cvnum();
word cvpos();
int cvreal();
int cvstr();
novalue datainit();
int defcset();
int deffile();
int defint();
int defshort();
int defstr();
int deref();
int doasgn();
int doimage();
novalue env_err();
novalue env_int();
int envset();
int equiv();
int eqv();
int err();
novalue error();
int Oescan();
novalue fatalerr();
int Ofield();
char *findfile();
int findline();
int fixtrap();
int fpetrap();
novalue failtrace();
int getstrg();
word hash();
char *icon_gcvt();
novalue iconhost();
novalue init();
novalue initalloc();
int interp();
int invoke();
long ipow();
double pow();
int itos();
int Okeywd();
int lexcmp();
int Olimit();
novalue listimage();
int Ollist();
int locate();
word longread();
long lstrlen();
novalue markblock();
dptr memb();
dptr memb_tbl();
int mkreal();
int Omkrec();
novalue mksubs();
novalue mvc();
int numcmp();
int nxttab();
int order();
novalue outimage();
struct b_coexpr *popact();
novalue postqual();
word prescan();
novalue printimage();
int pushact();
int putdmp();
int putpos();
int putstr();
int putsub();
int putint();
int qlcmp();
novalue qswap();
int qtos();
int radix();
novalue reclaim();
int resolve();
int rtos();
novalue rtrace();
novalue runerr();
novalue scollect();
int segvtrap();
novalue showlevel();
novalue showline();
int stkdump();
int ston();
novalue strace();
int strprc();
int strreq();
novalue sweep();
novalue syserr();
struct b_coexpr *topact();
int trcmp3();
int trefcmp();
novalue ttrace();
int tvalcmp();
int tvcmp4();
novalue xdisp();
novalue xtrace();

#ifdef MemMon
/*static*/ novalue mmnewline();
/*static*/ novalue mmcmd();
/*static*/ novalue mmdec();
/*static*/ novalue mmlen();
/*static*/ novalue mmforget();
/*static*/ novalue mmsizes();
/*static*/ novalue mmrefresh();
/*static*/ novalue mmstatic();

/*static*/ novalue MMOut();
/*static*/ novalue MMPause();
/*static*/ novalue MMShow();

novalue MMInit();
novalue MMTerm();
novalue MMAlc();
novalue MMBGC();
novalue MMEGC();
novalue MMMark();
novalue MMStat();
novalue MMStr();
novalue MMSMark();
#endif					/* MemMon */


#endif					/* Prototypes */
