/*
 *  Utility routines common to icont and iconx.
 */

#include "../h/config.h"
#include "../h/cpuconf.h"
#include <ctype.h>

#if IntBits == 16
/*
 * Long strlen
 */

long lstrlen(s)
char *s;
{
    long l = 0;
    while(*s++) l++;
    return l;
}
#endif					/* IntBits */

/* 
 * Write a long string in int-sized chunks.
 */

long longwrite(s,len,file)
FILE *file;
char *s;
long len;
{
   long tally = 0;
   int n = 0;
   int leftover, loopnum;
   char *p;

   loopnum = len / MaxInt;
   leftover = len % MaxInt;
   for (p = s, loopnum = len/MaxInt; loopnum; loopnum--) {
       n = fwrite(p,sizeof(char),MaxInt,file);
       tally += n;
       p += MaxInt;
   }
   if (leftover)
      n = fwrite(p,sizeof(char),leftover,file);
   tally += n;
   if (tally != len)
      return -1;
   else return tally;
   }

#ifdef EBCDIC
#include <ctype.h>

int tonum(c)
char c;
{
   if(isdigit(c)) return(c - '0');
   if( (c | ' ') >= 'A' & (c | ' ') <= 'I') return(( (c | ' ')- 'A' )+10);
   if( (c | ' ') >= 'J' & (c | ' ') <= 'R') return(( ((c | ' ')- 'J') + 9 )+10);
   if( (c | ' ') >= 'S' & (c | ' ') <= 'Z') return(( ((c | ' ')- 'S') + 18 )+10);
   return 0;
}
#endif               /* EBCDIC */
