/*
 * File: lmisc.c
 *  Contents: create, keywd, limit, llist
 */

#include "../h/config.h"
#include "../h/rt.h"
#include "../h/keyword.h"
#include "../h/version.h"

#ifdef PreProcess
/* include(../m4/lib.m4) /* */
/* */
#endif					/* PreProcess */

/*
 * The following code is operating-system dependent [@lmisc.01].  Include files
 *  that are system-dependent.
 */

#if PORT
   /* probably needs something */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA
#include "time.h"
#endif					/* AMIGA */

#if ATARI_ST || HIGHC_386 || MVS || VM
#include <time.h>
#endif					/* ATARI_ST || HIGHC_386 ... */

#if MACINTOSH
#if LSC
#include <unix.h>
#endif					/* LSC */
#if MPW
#include <types.h>
#include SysTime
#include <OSUtils.h>
#include <Events.h>
#endif					/* MPW */
#endif					/* MACINTOSH */

#if MSDOS
#include <time.h>
#if MICROSOFT
#include <sys/types.h>
#endif					/* MICROSOFT */
#endif					/* MSDOS */

#if OS2
#include <time.h>
#include <sys/types.h>
#endif					/* OS2 */

#if UNIX
#include <sys/types.h>
#include <sys/times.h>
#include SysTime
#endif					/* UNIX */

#if VMS
#include <types.h>
#include <time.h>
struct tms {
    time_t    tms_utime;	/* user time */
    time_t    tms_stime;	/* system time */
    time_t    tms_cutime;	/* user time, children */
    time_t    tms_cstime;	/* system time, children */
};
#endif					/* VMS */

/*
 * End of operating-system specific code.
 */

/*
 * create - return an entry block for a co-expression.
 */

OpBlock(create,1,"create",0)

Ocreate(entryp, cargp)
word *entryp;
register dptr cargp;
   {

#ifdef Coexpr
   register struct b_coexpr *sblkp;
   register struct b_refresh *rblkp;
   register dptr dp, ndp, dsp;
   register word *newsp;
   int na, nl, i;
   struct b_proc *cproc;

   /*
    * Get a new co-expression stack and initialize.
    */
   if ((sblkp = alccoexp()) == NULL) 
      RunErr(0, NULL);

   /*
    * Icon stack starts at word after co-expression stack block.  C stack
    *  starts at end of stack region on machines with down-growing C stacks
    *  and somewhere in the middle of the region.
    *
    * The C stack is aligned on a doubleword boundary.	For upgrowing
    *  stacks, the C stack starts in the middle of the stack portion
    *  of the static block.  For downgrowing stacks, the C stack starts
    *  at the end of the static block.
    */
   newsp = (word *)((char *)sblkp + sizeof(struct b_coexpr));

#ifdef UpStack
   sblkp->cstate[0] =
      ((word)((char *)sblkp + (stksize - sizeof(*sblkp))/2)
       &~(WordSize*2-1));
#else					/* UpStack */
   sblkp->cstate[0] =
	((word)((char *)sblkp + stksize - WordSize)&~(WordSize*2-1));
#endif					/* UpStack */

   sblkp->es_argp = (dptr )newsp;
   /*
    * Calculate number of arguments and number of local variables.
    *  na is nargs + 1 to include Arg0.
    */
   na = pfp->pf_nargs + 1;
   cproc = (struct b_proc *)BlkLoc(argp[0]);
   nl = cproc->ndynam;

   /*
    * Get a refresh block for the new co-expression.
    */
   if (blkreq((word)sizeof(struct b_refresh) +
         (na + nl) * sizeof(struct descrip)) == Error) 
      RunErr(0, NULL);
   rblkp = alcrefresh(entryp, na, nl);
   sblkp->freshblk.dword = D_Refresh;
   BlkLoc(sblkp->freshblk) = (union block *) rblkp;

   /*
    * Copy current procedure frame marker into refresh block.
    */
   rblkp->pfmkr = *pfp;
   rblkp->pfmkr.pf_pfp = 0;

   /*
    * Copy arguments into refresh block and onto new stack.
    */
   dp = &argp[0];
   ndp = &rblkp->elems[0];
   dsp = (dptr)newsp;
   for (i = 1; i <= na; i++) {
      *dsp++ = *dp;
      *ndp++ = *dp++;
      }

   /*
    * Copy procedure frame to new stack and point dsp to word after frame.
    */
   *((struct pf_marker *)dsp) = *pfp;
   sblkp->es_pfp = (struct pf_marker *)dsp;
   sblkp->es_pfp->pf_pfp = 0;
   dsp = (dptr)((word *)dsp + Vwsizeof(*pfp));
   sblkp->es_ipc.opnd = entryp;
   sblkp->es_gfp = 0;
   sblkp->es_efp = 0;
   sblkp->es_ilevel = 0;
   sblkp->tvalloc = NULL;

   /*
    * Copy locals to new stack and refresh block.
    */
   dp = &(pfp->pf_locals)[0];
   for (i = 1; i <= nl; i++) {
      *dsp++ = *dp;
      *ndp++ = *dp++;
      }
   /*
    * Push two null descriptors on the stack.
    */
   *dsp++ = nulldesc;
   *dsp++ = nulldesc;

   sblkp->es_sp = (word *)dsp - 1;

   /*
    * Return the new co-expression.
    */
   Arg0.dword = D_Coexpr;
   BlkLoc(Arg0) = (union block *) sblkp;
   Return;
#else					/* Coexpr */
   RunErr(-401, NULL);
#endif					/* Coexpr */

   }

static char *day[] = {
   "Sunday", "Monday", "Tuesday", "Wednesday",
   "Thursday", "Friday", "Saturday"
   };

static char *month[] = {
   "January", "February", "March", "April", "May", "June",
   "July", "August", "September", "October", "November", "December"
   };

/*
 * keywd - process keyword.
 */

char *feattab[] = {
#if AMIGA
   "Amiga",
#endif					/* AMIGA */
#if ATARI_ST
   "Atari ST",
#endif					/* ATARI_ST */
#if HIGHC_386
   "MS-DOS (386)",
#endif					/* HIGHC_386 */
#if MACINTOSH
   "Macintosh",
#endif					/* MACINTOSH */
#if MSDOS
   "MS-DOS",
#ifdef DosFncs
   "MS-DOS extensions",
#endif					/* DosFncs */
#endif					/* MSDOS */
#if MVS
   "MVS",
#endif					/* MVS */
#if OS2
   "OS/2",
#endif					/* OS2 */
#if PORT
   "PORT",
#endif					/* PORT */
#if UNIX
   "UNIX",
#endif					/* VM */
#if VMS
   "VMS",
#endif					/* VMS */
#ifdef Coexpr
   "co-expressions",
#endif					/* Coexpr */
#ifdef OverCheck
   "overflow checking",
#endif					/* OverCheck */
#ifdef Header
   "direct execution",
#endif					/* Header */
#ifdef EnvVars
   "environment variables",
#endif					/* EnvVars */
#ifdef TraceBack
   "error trace back",
#endif					/* TraceBack */
#ifdef ExecImages
   "executable images",
#endif					/* ExecImages */
#ifdef StrInvoke
   "string invocation",
#endif					/* StrInvoke */
#ifdef FixedRegions
   "fixed regions",
#else					/* FixedRegions */
   "expandable regions",
#endif					/* FixedRegions */
   ""
   };

LibDcl(keywd,0,"&keywd")
   {
   register int hour;
   register word i;
   register char *merid;
   char **p;
   char sbuf[MaxCvtLen];
   extern word coll_stat, coll_str, coll_blk, coll_tot;

/*
 * The following code is operating-system dependent [@lmisc.02].  Define
 *  structure if necessary for handling time.
 */

#if PORT
   struct tm *tbuf, *localtime();
   long time();
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || OS2
   struct tm *tbuf, *localtime();
   long time();
   long clock;
#endif					/* AMIGA || ATARI_ST || ... */

#if MSDOS
   struct tm *tbuf, *localtime();
   long clock;
#if LATTICE || MICROSOFT || TURBO
   long time();
#endif					/* LATTICE || MICROSOFT || TURBO */
#if MWC
   time_t time();
#endif					/* MWC */
#endif					/* MSDOS */

#if HIGHC_386
   struct tm *tbuf, *localtime();
   extern time_t    hc_strtime;
   time_t	    hc_curtime;
   long time();
   long clock;
#endif					/* HIGHC_386 */

#if MACINTOSH
   struct tm *tbuf, *localtime();
   long clock;
#if LSC
   unsigned long time();
#else					/* LSC */
   long time();
#endif					/* LSC */
#endif					/* MACINTOSH */

#if MVS || VM
   struct tm *tbuf;
   time_h xclock();
   time_t clock;
#endif					/* MVS || VM */

#if UNIX || VMS
   struct tm *tbuf, *localtime();
   struct tms tp;
   long time();
   long clock;
#endif					/* UNIX || VMS */

/*
 * End of operating-system specific code.
 */

   long runtim;

   /*
    * This is just plug and chug code.	For whatever keyword is desired,
    *  the appropriate value is dug out of the system and made into
    *  a suitable Icon value.
    *
    * A few special cases are worth noting:
    *  &pos, &random, &trace - built-in trapped variables are returned
    */
   switch ((int)IntVal(Arg0)) {
      case K_ASCII:
         Arg0.dword = D_Cset;
         BlkLoc(Arg0) = (union block *) &k_ascii;
         break;
      case K_CLOCK:
         if (strreq((word)8) == Error) 
            RunErr(0, NULL);
/*
 * The following code is operating-system dependent [@lmisc.03].  Get time.
 */

#if PORT
   time(&clock);
   tbuf = localtime(&clock);
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || MACINTOSH || MSDOS || OS2 || UNIX || VMS
   time(&clock);
   tbuf = localtime(&clock);
#endif					/* AMIGA || ATARI_ST || ... */

#if HIGHC_386
   time(&hc_curtime);
   tbuf = localtime(&hc_curtime);
#endif					/* HIGHC_386 */

#if MVS || VM
   time(&xclock);
   tbuf = localtime(&xclock);
#endif					/* MVS || VM */

/*
 * End of operating-system specific code.
 */

         sprintf(sbuf,"%02d:%02d:%02d",tbuf->tm_hour,tbuf->tm_min,
            tbuf->tm_sec);
         StrLen(Arg0) = 8;
         StrLoc(Arg0) = alcstr(sbuf,(word)8);
         break;
      case K_COLLECTIONS:
         MakeInt(coll_tot, &Arg0);
         Suspend;
         MakeInt(coll_stat, &Arg0);
         Suspend;
         MakeInt(coll_str, &Arg0);
         Suspend;
         MakeInt(coll_blk, &Arg0);
         Return;


      case K_CSET:
         Arg0.dword = D_Cset;
         BlkLoc(Arg0) = (union block *) &k_cset;
         break;
      case K_CURRENT:
         Arg0 = k_current;
         break;
      case K_DATE:
         if (strreq((word)10) == Error) 
            RunErr(0, NULL);

/*
 * The following code is operating-system dependent [@lmisc.04].  Get time.
 */

#if PORT
   time(&clock);
   tbuf = localtime(&clock);
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || MACINTOSH || MSDOS || OS2 || UNIX || VMS
   time(&clock);
   tbuf = localtime(&clock);
#endif					/* AMIGA || ATARI_ST || ... */

#if HIGHC_386
   time(&hc_curtime);
   tbuf = localtime(&hc_curtime);
#endif					/* HIGHC_386 */

#if MVS || VM
   time(&xclock);
   tbuf = localtime(&xclock);
#endif					/* MVS || VM */

/*
 * End of operating-system specific code.
 */

         sprintf(sbuf, "%04d/%02d/%02d",
                      (tbuf->tm_year)+1900,tbuf->tm_mon+1,tbuf->tm_mday);
         StrLen(Arg0) = 10;
         StrLoc(Arg0) = alcstr(sbuf,(word)10);
         break;
      case K_DATELINE:
/*
 * The following code is operating-system dependent [@lmisc.05].  Get time.
 */

#if PORT
   time(&clock);
   tbuf = localtime(&clock);
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || MACINTOSH || MSDOS || OS2 || UNIX || VMS
   time(&clock);
   tbuf = localtime(&clock);
#endif					/* AMIGA || ATARI_ST || ... */

#if HIGHC_386
   time(&hc_curtime);
   tbuf = localtime(&hc_curtime);
#endif					/* HIGHC_386 */

#if MVS || VM
   time(&xclock);
   tbuf = localtime(&xclock);
#endif					/* MVS || VM */

/*
 * End of operating-system specific code.
 */

         if ((hour = tbuf->tm_hour) >= 12) {
            merid = "pm";
            if (hour > 12)
               hour -= 12;
            }
         else {
            merid = "am";
            if (hour < 1)
               hour += 12;
            }
         sprintf(sbuf, "%s, %s %d, %d  %d:%02d %s",
            day[tbuf->tm_wday],
            month[tbuf->tm_mon], tbuf->tm_mday,
            1900 + tbuf->tm_year, hour, tbuf->tm_min, merid);
         if (strreq(i = strlen(sbuf)) == Error) 
            RunErr(0, NULL);
         StrLen(Arg0) = i;
         StrLoc(Arg0) = alcstr(sbuf, i);
         break;
      case K_DIGITS:
         Arg0.dword = D_Cset;
         BlkLoc(Arg0) = (union block *)&k_digits;
         break;


      case K_ERROR:
         Arg0.dword = D_Tvkywd;
         BlkLoc(Arg0) = (union block *)&tvky_err;
         break;

      case K_ERRORNUMBER:
         if (k_errornumber == 0)
            Fail;
         MakeInt((k_errornumber > 0 ? k_errornumber : -k_errornumber), &Arg0);
         break;
      case K_ERRORTEXT:
         if (k_errornumber == 0)
            Fail;
         StrLoc(Arg0) = k_errortext;
         StrLen(Arg0) = strlen(k_errortext);
         break;
      case K_ERRORVALUE:
         if (k_errornumber <= 0)
            Fail;
         Arg0 = k_errorvalue;
         break;
      case K_ERROUT:
         Arg0.dword = D_File;
         BlkLoc(Arg0) = (union block *)&k_errout;
         break;
      case K_FEATURES:
         p = feattab;
         for(;;) {
            StrLen(Arg0) = strlen(*p);
            if (StrLen(Arg0) == 0)
               Fail;
            StrLoc(Arg0) = *p;
            Suspend;
            p++;
            }
      case K_FILE:
         StrLoc(Arg0) = findfile(ipc.opnd);
         StrLen(Arg0) = strlen(StrLoc(Arg0));
         break;


      case K_HOST:
         iconhost(sbuf);
         if (strreq(i = strlen(sbuf)) == Error) 
            RunErr(0, NULL);
         StrLen(Arg0) = i;
         StrLoc(Arg0) = alcstr(sbuf, i);
         break;
      case K_INPUT:
         Arg0.dword = D_File;
         BlkLoc(Arg0) = (union block *)&k_input;
         break;
      case K_LCASE:
         Arg0.dword = D_Cset;
         BlkLoc(Arg0) = (union block *)&k_lcase;
         break;
      case K_LEVEL:
         MakeInt(k_level, &Arg0);
         break;
      case K_LINE:
         MakeInt(findline(ipc.opnd), &Arg0);
         break;
      case K_MAIN:
         Arg0 = k_main;
         break;
      case K_OUTPUT:
         Arg0.dword = D_File;
         BlkLoc(Arg0) = (union block *)&k_output;
         break;
      case K_POS:
         Arg0.dword = D_Tvkywd;
         BlkLoc(Arg0) = (union block *) &tvky_pos;
         break;
      case K_RANDOM:
         Arg0.dword = D_Tvkywd;
         BlkLoc(Arg0) = (union block *) &tvky_ran;
         break;
      case K_REGIONS:
         MakeInt(DiffPtrs(statend,statbase), &Arg0);
         Suspend;
         MakeInt(DiffPtrs(strend,strbase), &Arg0);
         Suspend;
         MakeInt(DiffPtrs(blkend,blkbase), &Arg0);
         Return;
      case K_SOURCE:

#ifndef Coexpr
         Arg(0) = k_main;
#else					/* Coexpr */
 	 Arg0.dword = D_Coexpr;
 	 BlkLoc(Arg0) =
            (union block *)topact((struct b_coexpr *)BlkLoc(k_current));
#endif					/* Coexpr */

         break;
      case K_STORAGE:
         MakeInt(DiffPtrs(statfree,statbase), &Arg0);
         Suspend;
         MakeInt(DiffPtrs(strfree,strbase), &Arg0);
         Suspend;
         MakeInt(DiffPtrs(blkfree,blkbase), &Arg0);
         Return;
      case K_SUBJECT:
         Arg0.dword = D_Tvkywd;
         BlkLoc(Arg0) = (union block *) &tvky_sub;
         break;
      case K_TIME:

/*
 * The following code is operating-system dependent [@lmisc.06].  Get time.
 */

#if PORT
   /* needs something */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || MSDOS || OS2
         runtim = 1000 * (time(NULL) - starttime);
#endif					/* AMIGA || ATARI_ST || MSDOS */

#if HIGHC_386
         time(&hc_curtime);
         runtim = 1000 * (long)difftime(hc_curtime,hc_strtime);
#endif					/* HIGHC_386 */

#if MACINTOSH
         runtim = 1000 * ((extended)(TickCount() - starttime) / (extended)Hz);
#endif					/* MACINTOSH */

#if MVS || VM
         runtim = 1000 * ((long)xclock() - starttime);
#endif					/* MVS || VM */

#if UNIX || VMS
         times(&tp);
         runtim = 1000 * ((tp.tms_utime - starttime) / (double)Hz);
#endif					/* UNIX || VMS */

/*
 * End of operating-system specific code.
 */

         MakeInt(runtim, &Arg0);
         break;
      case K_TRACE:
         Arg0.dword = D_Tvkywd;
         BlkLoc(Arg0) = (union block *)&tvky_trc;
         break;
      case K_UCASE:
         Arg0.dword = D_Cset;
         BlkLoc(Arg0) = (union block *)&k_ucase;
         break;
      case K_VERSION:
         if (strreq(i = strlen(VERSION)) == Error) 
            RunErr(0, NULL);
         StrLen(Arg0) = i;
         StrLoc(Arg0) = VERSION;
         break;
      default:
         syserr("keyword: unknown keyword type.");
      }
   Return;
   }


/*
 * limit - explicit limitation initialization.
 */


#ifdef WATERLOO_C_V3_0
struct b_iproc Blimit = {
	T_Proc,
	Vsizeof(struct b_proc),
	Olimit,
	2,
	-1,
	0,
	0,
	{sizeof(BackSlash)-1,BackSlash}}; Olimit(nargs,cargp,sptr) register dptr cargp;
#else					/* WATERLOO_C_V3_0 */
LibDcl(limit,2,BackSlash)
#endif					/* WATERLOO_C_V3_0 */

   {
   long l;

   /*
    * The limit is both passed and returned in Arg0.  The limit must
    *  be an integer.  If the limit is 0, the expression being evaluated
    *  fails.  If the limit is < 0, it is an error.  Note that the
    *  result produced by limit is ultimately picked up by the lsusp
    *  function.
    */
   if (DeRef(Arg0) == Error) 
      RunErr(0, NULL);

   switch (cvint(&Arg0, &l)) {

      case T_Integer:
         MakeInt(l, &Arg0);
         break;

      default:
         RunErr(101, &Arg0);
      }

   if (l < 0) 
      RunErr(205, &Arg0);
   if (l == 0)
      Fail;
   Return;
   }


/*
 * [ ... ] - create an explicitly specified list.
 */

LibDcl(llist,-1,"[...]")
   {
   register word i;
   register struct b_list *hp;
   register struct b_lelem *bp;
   word nslots;

   /*
    * Round the number of elements in the list (as indicated by nargs)
    *  up to MinListSlots and ensure space for the list.
    */
   nslots = nargs;
   if (nslots < MinListSlots)
      nslots = MinListSlots;

   if (blkreq((word)sizeof(struct b_list) + sizeof(struct b_lelem) +
         nslots * sizeof(struct descrip)) == Error) 
      RunErr(0, NULL);

   /*
    * Allocate the list and a list block.
    */
   hp = alclist((word)nargs);
   bp = alclstb(nslots, (word)0, (word)nargs);

   /*
    * Make the list block just allocated into the first and last blocks
    *  for the list.
    */
   hp->listhead.dword = hp->listtail.dword = D_Lelem;
   BlkLoc(hp->listhead) = BlkLoc(hp->listtail) = (union block *) bp;
   /*
    * Dereference each argument in turn and assign it to a list element.
    */
   for (i = 1; i <= nargs; i++) {
      if (DeRef(Arg(i)) == Error) 
         RunErr(0, NULL);
      bp->lslots[i-1] = Arg(i);
      }
   /*
    * Point Arg0 at the new list and return it.
    */
   ArgType(0) = D_List;
   Arg(0).vword.bptr = (union block *)hp;
   Return;
   }
